TerminalFactorySpi (Java SE 26 & JDK 26)
Description: declaration: module: java.smartcardio, package: javax.smartcardio, class: TerminalFactorySpi
Keywords: javax.smartcardio.TerminalFactorySpi class

# Class TerminalFactorySpi

java.lang.Object
javax.smartcardio.TerminalFactorySpi

public abstract class TerminalFactorySpi extends Object
The TerminalFactorySpi class defines the service provider interface. Applications do not access this class directly, instead see TerminalFactory.

Service providers that want to write a new implementation should define a concrete subclass of TerminalFactorySpi with a constructor that takes an `Object` as parameter. That class needs to be registered in a Provider. The engine type is `TerminalFactory`. Service providers also need to implement subclasses of the abstract classes CardTerminals, CardTerminal, Card, and CardChannel.

For example:

    file MyProvider.java:

     package com.somedomain.card;

     import java.security.Provider;

     public class MyProvider extends Provider {
         public MyProvider() {
             super("MyProvider", 1.0d, "Smart Card Example");
             put("TerminalFactory.MyType", "com.somedomain.card.MySpi");
         }
     }

    file MySpi.java

     package com.somedomain.card;

     import javax.smartcardio.*;

     public class MySpi extends TerminalFactoySpi {
          public MySpi(Object parameter) {
              // initialize as appropriate
          }
          protected CardTerminals engineTerminals() {
              // add implementation code here
          }
     }

Since:
  1.6
See Also:
  - `TerminalFactory`
  - `Provider`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `TerminalFactorySpi()`
  Constructs a new TerminalFactorySpi object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract CardTerminals`
  `engineTerminals()`
  Returns the CardTerminals created by this factory.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### TerminalFactorySpi

    protected TerminalFactorySpi()
    Constructs a new TerminalFactorySpi object.

    This class is part of the service provider interface and not accessed directly by applications. Applications should use TerminalFactory objects, which can be obtained by calling one of the TerminalFactory.getInstance() methods.

    Concrete subclasses should define a constructor that takes an `Object` as parameter. It will be invoked when an application calls one of the TerminalFactory.getInstance() methods and receives the `params` object specified by the application.

- ## Method Details

  - ### engineTerminals

    protected abstract CardTerminals engineTerminals()
    Returns the CardTerminals created by this factory.
    Returns:
      the CardTerminals created by this factory.